// RUN: llvm-mc -triple i386 --show-encoding %s | FileCheck %s

// CHECK: vcomxsd %xmm3, %xmm2
// CHECK: encoding: [0x62,0xf1,0xff,0x08,0x2f,0xd3]
          vcomxsd %xmm3, %xmm2

// CHECK: vcomxsd {sae}, %xmm3, %xmm2
// CHECK: encoding: [0x62,0xf1,0xff,0x18,0x2f,0xd3]
          vcomxsd {sae}, %xmm3, %xmm2

// CHECK: vcomxsd  268435456(%esp,%esi,8), %xmm2
// CHECK: encoding: [0x62,0xf1,0xff,0x08,0x2f,0x94,0xf4,0x00,0x00,0x00,0x10]
          vcomxsd  268435456(%esp,%esi,8), %xmm2

// CHECK: vcomxsd  291(%edi,%eax,4), %xmm2
// CHECK: encoding: [0x62,0xf1,0xff,0x08,0x2f,0x94,0x87,0x23,0x01,0x00,0x00]
          vcomxsd  291(%edi,%eax,4), %xmm2

// CHECK: vcomxsd  (%eax), %xmm2
// CHECK: encoding: [0x62,0xf1,0xff,0x08,0x2f,0x10]
          vcomxsd  (%eax), %xmm2

// CHECK: vcomxsd  -256(,%ebp,2), %xmm2
// CHECK: encoding: [0x62,0xf1,0xff,0x08,0x2f,0x14,0x6d,0x00,0xff,0xff,0xff]
          vcomxsd  -256(,%ebp,2), %xmm2

// CHECK: vcomxsd  1016(%ecx), %xmm2
// CHECK: encoding: [0x62,0xf1,0xff,0x08,0x2f,0x51,0x7f]
          vcomxsd  1016(%ecx), %xmm2

// CHECK: vcomxsd  -1024(%edx), %xmm2
// CHECK: encoding: [0x62,0xf1,0xff,0x08,0x2f,0x52,0x80]
          vcomxsd  -1024(%edx), %xmm2

// CHECK: vcomxsh %xmm3, %xmm2
// CHECK: encoding: [0x62,0xf5,0x7e,0x08,0x2f,0xd3]
          vcomxsh %xmm3, %xmm2

// CHECK: vcomxsh {sae}, %xmm3, %xmm2
// CHECK: encoding: [0x62,0xf5,0x7e,0x18,0x2f,0xd3]
          vcomxsh {sae}, %xmm3, %xmm2

// CHECK: vcomxsh  268435456(%esp,%esi,8), %xmm2
// CHECK: encoding: [0x62,0xf5,0x7e,0x08,0x2f,0x94,0xf4,0x00,0x00,0x00,0x10]
          vcomxsh  268435456(%esp,%esi,8), %xmm2

// CHECK: vcomxsh  291(%edi,%eax,4), %xmm2
// CHECK: encoding: [0x62,0xf5,0x7e,0x08,0x2f,0x94,0x87,0x23,0x01,0x00,0x00]
          vcomxsh  291(%edi,%eax,4), %xmm2

// CHECK: vcomxsh  (%eax), %xmm2
// CHECK: encoding: [0x62,0xf5,0x7e,0x08,0x2f,0x10]
          vcomxsh  (%eax), %xmm2

// CHECK: vcomxsh  -64(,%ebp,2), %xmm2
// CHECK: encoding: [0x62,0xf5,0x7e,0x08,0x2f,0x14,0x6d,0xc0,0xff,0xff,0xff]
          vcomxsh  -64(,%ebp,2), %xmm2

// CHECK: vcomxsh  254(%ecx), %xmm2
// CHECK: encoding: [0x62,0xf5,0x7e,0x08,0x2f,0x51,0x7f]
          vcomxsh  254(%ecx), %xmm2

// CHECK: vcomxsh  -256(%edx), %xmm2
// CHECK: encoding: [0x62,0xf5,0x7e,0x08,0x2f,0x52,0x80]
          vcomxsh  -256(%edx), %xmm2

// CHECK: vcomxss %xmm3, %xmm2
// CHECK: encoding: [0x62,0xf1,0x7e,0x08,0x2f,0xd3]
          vcomxss %xmm3, %xmm2

// CHECK: vcomxss {sae}, %xmm3, %xmm2
// CHECK: encoding: [0x62,0xf1,0x7e,0x18,0x2f,0xd3]
          vcomxss {sae}, %xmm3, %xmm2

// CHECK: vcomxss  268435456(%esp,%esi,8), %xmm2
// CHECK: encoding: [0x62,0xf1,0x7e,0x08,0x2f,0x94,0xf4,0x00,0x00,0x00,0x10]
          vcomxss  268435456(%esp,%esi,8), %xmm2

// CHECK: vcomxss  291(%edi,%eax,4), %xmm2
// CHECK: encoding: [0x62,0xf1,0x7e,0x08,0x2f,0x94,0x87,0x23,0x01,0x00,0x00]
          vcomxss  291(%edi,%eax,4), %xmm2

// CHECK: vcomxss  (%eax), %xmm2
// CHECK: encoding: [0x62,0xf1,0x7e,0x08,0x2f,0x10]
          vcomxss  (%eax), %xmm2

// CHECK: vcomxss  -128(,%ebp,2), %xmm2
// CHECK: encoding: [0x62,0xf1,0x7e,0x08,0x2f,0x14,0x6d,0x80,0xff,0xff,0xff]
          vcomxss  -128(,%ebp,2), %xmm2

// CHECK: vcomxss  508(%ecx), %xmm2
// CHECK: encoding: [0x62,0xf1,0x7e,0x08,0x2f,0x51,0x7f]
          vcomxss  508(%ecx), %xmm2

// CHECK: vcomxss  -512(%edx), %xmm2
// CHECK: encoding: [0x62,0xf1,0x7e,0x08,0x2f,0x52,0x80]
          vcomxss  -512(%edx), %xmm2

// CHECK: vucomxsd %xmm3, %xmm2
// CHECK: encoding: [0x62,0xf1,0xff,0x08,0x2e,0xd3]
          vucomxsd %xmm3, %xmm2

// CHECK: vucomxsd {sae}, %xmm3, %xmm2
// CHECK: encoding: [0x62,0xf1,0xff,0x18,0x2e,0xd3]
          vucomxsd {sae}, %xmm3, %xmm2

// CHECK: vucomxsd  268435456(%esp,%esi,8), %xmm2
// CHECK: encoding: [0x62,0xf1,0xff,0x08,0x2e,0x94,0xf4,0x00,0x00,0x00,0x10]
          vucomxsd  268435456(%esp,%esi,8), %xmm2

// CHECK: vucomxsd  291(%edi,%eax,4), %xmm2
// CHECK: encoding: [0x62,0xf1,0xff,0x08,0x2e,0x94,0x87,0x23,0x01,0x00,0x00]
          vucomxsd  291(%edi,%eax,4), %xmm2

// CHECK: vucomxsd  (%eax), %xmm2
// CHECK: encoding: [0x62,0xf1,0xff,0x08,0x2e,0x10]
          vucomxsd  (%eax), %xmm2

// CHECK: vucomxsd  -256(,%ebp,2), %xmm2
// CHECK: encoding: [0x62,0xf1,0xff,0x08,0x2e,0x14,0x6d,0x00,0xff,0xff,0xff]
          vucomxsd  -256(,%ebp,2), %xmm2

// CHECK: vucomxsd  1016(%ecx), %xmm2
// CHECK: encoding: [0x62,0xf1,0xff,0x08,0x2e,0x51,0x7f]
          vucomxsd  1016(%ecx), %xmm2

// CHECK: vucomxsd  -1024(%edx), %xmm2
// CHECK: encoding: [0x62,0xf1,0xff,0x08,0x2e,0x52,0x80]
          vucomxsd  -1024(%edx), %xmm2

// CHECK: vucomxsh %xmm3, %xmm2
// CHECK: encoding: [0x62,0xf5,0x7e,0x08,0x2e,0xd3]
          vucomxsh %xmm3, %xmm2

// CHECK: vucomxsh {sae}, %xmm3, %xmm2
// CHECK: encoding: [0x62,0xf5,0x7e,0x18,0x2e,0xd3]
          vucomxsh {sae}, %xmm3, %xmm2

// CHECK: vucomxsh  268435456(%esp,%esi,8), %xmm2
// CHECK: encoding: [0x62,0xf5,0x7e,0x08,0x2e,0x94,0xf4,0x00,0x00,0x00,0x10]
          vucomxsh  268435456(%esp,%esi,8), %xmm2

// CHECK: vucomxsh  291(%edi,%eax,4), %xmm2
// CHECK: encoding: [0x62,0xf5,0x7e,0x08,0x2e,0x94,0x87,0x23,0x01,0x00,0x00]
          vucomxsh  291(%edi,%eax,4), %xmm2

// CHECK: vucomxsh  (%eax), %xmm2
// CHECK: encoding: [0x62,0xf5,0x7e,0x08,0x2e,0x10]
          vucomxsh  (%eax), %xmm2

// CHECK: vucomxsh  -64(,%ebp,2), %xmm2
// CHECK: encoding: [0x62,0xf5,0x7e,0x08,0x2e,0x14,0x6d,0xc0,0xff,0xff,0xff]
          vucomxsh  -64(,%ebp,2), %xmm2

// CHECK: vucomxsh  254(%ecx), %xmm2
// CHECK: encoding: [0x62,0xf5,0x7e,0x08,0x2e,0x51,0x7f]
          vucomxsh  254(%ecx), %xmm2

// CHECK: vucomxsh  -256(%edx), %xmm2
// CHECK: encoding: [0x62,0xf5,0x7e,0x08,0x2e,0x52,0x80]
          vucomxsh  -256(%edx), %xmm2

// CHECK: vucomxss %xmm3, %xmm2
// CHECK: encoding: [0x62,0xf1,0x7e,0x08,0x2e,0xd3]
          vucomxss %xmm3, %xmm2

// CHECK: vucomxss {sae}, %xmm3, %xmm2
// CHECK: encoding: [0x62,0xf1,0x7e,0x18,0x2e,0xd3]
          vucomxss {sae}, %xmm3, %xmm2

// CHECK: vucomxss  268435456(%esp,%esi,8), %xmm2
// CHECK: encoding: [0x62,0xf1,0x7e,0x08,0x2e,0x94,0xf4,0x00,0x00,0x00,0x10]
          vucomxss  268435456(%esp,%esi,8), %xmm2

// CHECK: vucomxss  291(%edi,%eax,4), %xmm2
// CHECK: encoding: [0x62,0xf1,0x7e,0x08,0x2e,0x94,0x87,0x23,0x01,0x00,0x00]
          vucomxss  291(%edi,%eax,4), %xmm2

// CHECK: vucomxss  (%eax), %xmm2
// CHECK: encoding: [0x62,0xf1,0x7e,0x08,0x2e,0x10]
          vucomxss  (%eax), %xmm2

// CHECK: vucomxss  -128(,%ebp,2), %xmm2
// CHECK: encoding: [0x62,0xf1,0x7e,0x08,0x2e,0x14,0x6d,0x80,0xff,0xff,0xff]
          vucomxss  -128(,%ebp,2), %xmm2

// CHECK: vucomxss  508(%ecx), %xmm2
// CHECK: encoding: [0x62,0xf1,0x7e,0x08,0x2e,0x51,0x7f]
          vucomxss  508(%ecx), %xmm2

// CHECK: vucomxss  -512(%edx), %xmm2
// CHECK: encoding: [0x62,0xf1,0x7e,0x08,0x2e,0x52,0x80]
          vucomxss  -512(%edx), %xmm2

