// RUN: llvm-mc -triple x86_64 --show-encoding %s | FileCheck %s

// CHECK: vmovd  268435456(%rbp,%r14,8), %xmm22
// CHECK: encoding: [0x62,0xa1,0x7d,0x08,0x6e,0xb4,0xf5,0x00,0x00,0x00,0x10]
          vmovd  268435456(%rbp,%r14,8), %xmm22

// CHECK: vmovd  291(%r8,%rax,4), %xmm22
// CHECK: encoding: [0x62,0xc1,0x7d,0x08,0x6e,0xb4,0x80,0x23,0x01,0x00,0x00]
          vmovd  291(%r8,%rax,4), %xmm22

// CHECK: vmovd  (%rip), %xmm22
// CHECK: encoding: [0x62,0xe1,0x7d,0x08,0x6e,0x35,0x00,0x00,0x00,0x00]
          vmovd  (%rip), %xmm22

// CHECK: vmovd  -128(,%rbp,2), %xmm22
// CHECK: encoding: [0x62,0xe1,0x7d,0x08,0x6e,0x34,0x6d,0x80,0xff,0xff,0xff]
          vmovd  -128(,%rbp,2), %xmm22

// CHECK: vmovd  508(%rcx), %xmm22
// CHECK: encoding: [0x62,0xe1,0x7d,0x08,0x6e,0x71,0x7f]
          vmovd  508(%rcx), %xmm22

// CHECK: vmovd  -512(%rdx), %xmm22
// CHECK: encoding: [0x62,0xe1,0x7d,0x08,0x6e,0x72,0x80]
          vmovd  -512(%rdx), %xmm22

// CHECK: vmovd  %xmm23, 268435456(%rbp,%r14,8)
// CHECK: encoding: [0x62,0xa1,0x7d,0x08,0x7e,0xbc,0xf5,0x00,0x00,0x00,0x10]
          vmovd  %xmm23, 268435456(%rbp,%r14,8)

// CHECK: vmovd  %xmm23, 291(%r8,%rax,4)
// CHECK: encoding: [0x62,0xc1,0x7d,0x08,0x7e,0xbc,0x80,0x23,0x01,0x00,0x00]
          vmovd  %xmm23, 291(%r8,%rax,4)

// CHECK: vmovd  %xmm23, (%rip)
// CHECK: encoding: [0x62,0xe1,0x7d,0x08,0x7e,0x3d,0x00,0x00,0x00,0x00]
          vmovd  %xmm23, (%rip)

// CHECK: vmovd  %xmm23, -128(,%rbp,2)
// CHECK: encoding: [0x62,0xe1,0x7d,0x08,0x7e,0x3c,0x6d,0x80,0xff,0xff,0xff]
          vmovd  %xmm23, -128(,%rbp,2)

// CHECK: vmovd  %xmm23, 508(%rcx)
// CHECK: encoding: [0x62,0xe1,0x7d,0x08,0x7e,0x79,0x7f]
          vmovd  %xmm23, 508(%rcx)

// CHECK: vmovd  %xmm23, -512(%rdx)
// CHECK: encoding: [0x62,0xe1,0x7d,0x08,0x7e,0x7a,0x80]
          vmovd  %xmm23, -512(%rdx)

// CHECK: vmovw  268435456(%rbp,%r14,8), %xmm22
// CHECK: encoding: [0x62,0xa5,0x7d,0x08,0x6e,0xb4,0xf5,0x00,0x00,0x00,0x10]
          vmovw  268435456(%rbp,%r14,8), %xmm22

// CHECK: vmovw  291(%r8,%rax,4), %xmm22
// CHECK: encoding: [0x62,0xc5,0x7d,0x08,0x6e,0xb4,0x80,0x23,0x01,0x00,0x00]
          vmovw  291(%r8,%rax,4), %xmm22

// CHECK: vmovw  (%rip), %xmm22
// CHECK: encoding: [0x62,0xe5,0x7d,0x08,0x6e,0x35,0x00,0x00,0x00,0x00]
          vmovw  (%rip), %xmm22

// CHECK: vmovw  -64(,%rbp,2), %xmm22
// CHECK: encoding: [0x62,0xe5,0x7d,0x08,0x6e,0x34,0x6d,0xc0,0xff,0xff,0xff]
          vmovw  -64(,%rbp,2), %xmm22

// CHECK: vmovw  254(%rcx), %xmm22
// CHECK: encoding: [0x62,0xe5,0x7d,0x08,0x6e,0x71,0x7f]
          vmovw  254(%rcx), %xmm22

// CHECK: vmovw  -256(%rdx), %xmm22
// CHECK: encoding: [0x62,0xe5,0x7d,0x08,0x6e,0x72,0x80]
          vmovw  -256(%rdx), %xmm22

// CHECK: vmovw  %xmm23, 268435456(%rbp,%r14,8)
// CHECK: encoding: [0x62,0xa5,0x7d,0x08,0x7e,0xbc,0xf5,0x00,0x00,0x00,0x10]
          vmovw  %xmm23, 268435456(%rbp,%r14,8)

// CHECK: vmovw  %xmm23, 291(%r8,%rax,4)
// CHECK: encoding: [0x62,0xc5,0x7d,0x08,0x7e,0xbc,0x80,0x23,0x01,0x00,0x00]
          vmovw  %xmm23, 291(%r8,%rax,4)

// CHECK: vmovw  %xmm23, (%rip)
// CHECK: encoding: [0x62,0xe5,0x7d,0x08,0x7e,0x3d,0x00,0x00,0x00,0x00]
          vmovw  %xmm23, (%rip)

// CHECK: vmovw  %xmm23, -64(,%rbp,2)
// CHECK: encoding: [0x62,0xe5,0x7d,0x08,0x7e,0x3c,0x6d,0xc0,0xff,0xff,0xff]
          vmovw  %xmm23, -64(,%rbp,2)

// CHECK: vmovw  %xmm23, 254(%rcx)
// CHECK: encoding: [0x62,0xe5,0x7d,0x08,0x7e,0x79,0x7f]
          vmovw  %xmm23, 254(%rcx)

// CHECK: vmovw  %xmm23, -256(%rdx)
// CHECK: encoding: [0x62,0xe5,0x7d,0x08,0x7e,0x7a,0x80]
          vmovw  %xmm23, -256(%rdx)
