// RUN: llvm-mc -triple x86_64 -x86-asm-syntax=intel -output-asm-variant=1 --show-encoding %s | FileCheck %s

// CHECK: vmovd xmm22, dword ptr [rbp + 8*r14 + 268435456]
// CHECK: encoding: [0x62,0xa1,0x7d,0x08,0x6e,0xb4,0xf5,0x00,0x00,0x00,0x10]
          vmovd xmm22, dword ptr [rbp + 8*r14 + 268435456]

// CHECK: vmovd xmm22, dword ptr [r8 + 4*rax + 291]
// CHECK: encoding: [0x62,0xc1,0x7d,0x08,0x6e,0xb4,0x80,0x23,0x01,0x00,0x00]
          vmovd xmm22, dword ptr [r8 + 4*rax + 291]

// CHECK: vmovd xmm22, dword ptr [rip]
// CHECK: encoding: [0x62,0xe1,0x7d,0x08,0x6e,0x35,0x00,0x00,0x00,0x00]
          vmovd xmm22, dword ptr [rip]

// CHECK: vmovd xmm22, dword ptr [2*rbp - 128]
// CHECK: encoding: [0x62,0xe1,0x7d,0x08,0x6e,0x34,0x6d,0x80,0xff,0xff,0xff]
          vmovd xmm22, dword ptr [2*rbp - 128]

// CHECK: vmovd xmm22, dword ptr [rcx + 508]
// CHECK: encoding: [0x62,0xe1,0x7d,0x08,0x6e,0x71,0x7f]
          vmovd xmm22, dword ptr [rcx + 508]

// CHECK: vmovd xmm22, dword ptr [rdx - 512]
// CHECK: encoding: [0x62,0xe1,0x7d,0x08,0x6e,0x72,0x80]
          vmovd xmm22, dword ptr [rdx - 512]

// CHECK: vmovd dword ptr [rbp + 8*r14 + 268435456], xmm23
// CHECK: encoding: [0x62,0xa1,0x7d,0x08,0x7e,0xbc,0xf5,0x00,0x00,0x00,0x10]
          vmovd dword ptr [rbp + 8*r14 + 268435456], xmm23

// CHECK: vmovd dword ptr [r8 + 4*rax + 291], xmm23
// CHECK: encoding: [0x62,0xc1,0x7d,0x08,0x7e,0xbc,0x80,0x23,0x01,0x00,0x00]
          vmovd dword ptr [r8 + 4*rax + 291], xmm23

// CHECK: vmovd dword ptr [rip], xmm23
// CHECK: encoding: [0x62,0xe1,0x7d,0x08,0x7e,0x3d,0x00,0x00,0x00,0x00]
          vmovd dword ptr [rip], xmm23

// CHECK: vmovd dword ptr [2*rbp - 128], xmm23
// CHECK: encoding: [0x62,0xe1,0x7d,0x08,0x7e,0x3c,0x6d,0x80,0xff,0xff,0xff]
          vmovd dword ptr [2*rbp - 128], xmm23

// CHECK: vmovd dword ptr [rcx + 508], xmm23
// CHECK: encoding: [0x62,0xe1,0x7d,0x08,0x7e,0x79,0x7f]
          vmovd dword ptr [rcx + 508], xmm23

// CHECK: vmovd dword ptr [rdx - 512], xmm23
// CHECK: encoding: [0x62,0xe1,0x7d,0x08,0x7e,0x7a,0x80]
          vmovd dword ptr [rdx - 512], xmm23

// CHECK: vmovw xmm22, word ptr [rbp + 8*r14 + 268435456]
// CHECK: encoding: [0x62,0xa5,0x7d,0x08,0x6e,0xb4,0xf5,0x00,0x00,0x00,0x10]
          vmovw xmm22, word ptr [rbp + 8*r14 + 268435456]

// CHECK: vmovw xmm22, word ptr [r8 + 4*rax + 291]
// CHECK: encoding: [0x62,0xc5,0x7d,0x08,0x6e,0xb4,0x80,0x23,0x01,0x00,0x00]
          vmovw xmm22, word ptr [r8 + 4*rax + 291]

// CHECK: vmovw xmm22, word ptr [rip]
// CHECK: encoding: [0x62,0xe5,0x7d,0x08,0x6e,0x35,0x00,0x00,0x00,0x00]
          vmovw xmm22, word ptr [rip]

// CHECK: vmovw xmm22, word ptr [2*rbp - 64]
// CHECK: encoding: [0x62,0xe5,0x7d,0x08,0x6e,0x34,0x6d,0xc0,0xff,0xff,0xff]
          vmovw xmm22, word ptr [2*rbp - 64]

// CHECK: vmovw xmm22, word ptr [rcx + 254]
// CHECK: encoding: [0x62,0xe5,0x7d,0x08,0x6e,0x71,0x7f]
          vmovw xmm22, word ptr [rcx + 254]

// CHECK: vmovw xmm22, word ptr [rdx - 256]
// CHECK: encoding: [0x62,0xe5,0x7d,0x08,0x6e,0x72,0x80]
          vmovw xmm22, word ptr [rdx - 256]

// CHECK: vmovw word ptr [rbp + 8*r14 + 268435456], xmm23
// CHECK: encoding: [0x62,0xa5,0x7d,0x08,0x7e,0xbc,0xf5,0x00,0x00,0x00,0x10]
          vmovw word ptr [rbp + 8*r14 + 268435456], xmm23

// CHECK: vmovw word ptr [r8 + 4*rax + 291], xmm23
// CHECK: encoding: [0x62,0xc5,0x7d,0x08,0x7e,0xbc,0x80,0x23,0x01,0x00,0x00]
          vmovw word ptr [r8 + 4*rax + 291], xmm23

// CHECK: vmovw word ptr [rip], xmm23
// CHECK: encoding: [0x62,0xe5,0x7d,0x08,0x7e,0x3d,0x00,0x00,0x00,0x00]
          vmovw word ptr [rip], xmm23

// CHECK: vmovw word ptr [2*rbp - 64], xmm23
// CHECK: encoding: [0x62,0xe5,0x7d,0x08,0x7e,0x3c,0x6d,0xc0,0xff,0xff,0xff]
          vmovw word ptr [2*rbp - 64], xmm23

// CHECK: vmovw word ptr [rcx + 254], xmm23
// CHECK: encoding: [0x62,0xe5,0x7d,0x08,0x7e,0x79,0x7f]
          vmovw word ptr [rcx + 254], xmm23

// CHECK: vmovw word ptr [rdx - 256], xmm23
// CHECK: encoding: [0x62,0xe5,0x7d,0x08,0x7e,0x7a,0x80]
          vmovw word ptr [rdx - 256], xmm23
