// RUN: llvm-mc -triple x86_64-unknown-unknown --show-encoding < %s  | FileCheck %s

// CHECK: vmovrsb  268435456(%rbp,%r14,8), %zmm22
// CHECK: encoding: [0x62,0xa5,0x7f,0x48,0x6f,0xb4,0xf5,0x00,0x00,0x00,0x10]
          vmovrsb  268435456(%rbp,%r14,8), %zmm22

// CHECK: vmovrsb  291(%r8,%rax,4), %zmm22 {%k7}
// CHECK: encoding: [0x62,0xc5,0x7f,0x4f,0x6f,0xb4,0x80,0x23,0x01,0x00,0x00]
          vmovrsb  291(%r8,%rax,4), %zmm22 {%k7}

// CHECK: vmovrsb  (%rip), %zmm22
// CHECK: encoding: [0x62,0xe5,0x7f,0x48,0x6f,0x35,0x00,0x00,0x00,0x00]
          vmovrsb  (%rip), %zmm22

// CHECK: vmovrsb  -2048(,%rbp,2), %zmm22
// CHECK: encoding: [0x62,0xe5,0x7f,0x48,0x6f,0x34,0x6d,0x00,0xf8,0xff,0xff]
          vmovrsb  -2048(,%rbp,2), %zmm22

// CHECK: vmovrsb  8128(%rcx), %zmm22 {%k7} {z}
// CHECK: encoding: [0x62,0xe5,0x7f,0xcf,0x6f,0x71,0x7f]
          vmovrsb  8128(%rcx), %zmm22 {%k7} {z}

// CHECK: vmovrsb  -8192(%rdx), %zmm22 {%k7} {z}
// CHECK: encoding: [0x62,0xe5,0x7f,0xcf,0x6f,0x72,0x80]
          vmovrsb  -8192(%rdx), %zmm22 {%k7} {z}

// CHECK: vmovrsd  268435456(%rbp,%r14,8), %zmm22
// CHECK: encoding: [0x62,0xa5,0x7e,0x48,0x6f,0xb4,0xf5,0x00,0x00,0x00,0x10]
          vmovrsd  268435456(%rbp,%r14,8), %zmm22

// CHECK: vmovrsd  291(%r8,%rax,4), %zmm22 {%k7}
// CHECK: encoding: [0x62,0xc5,0x7e,0x4f,0x6f,0xb4,0x80,0x23,0x01,0x00,0x00]
          vmovrsd  291(%r8,%rax,4), %zmm22 {%k7}

// CHECK: vmovrsd  (%rip), %zmm22
// CHECK: encoding: [0x62,0xe5,0x7e,0x48,0x6f,0x35,0x00,0x00,0x00,0x00]
          vmovrsd  (%rip), %zmm22

// CHECK: vmovrsd  -2048(,%rbp,2), %zmm22
// CHECK: encoding: [0x62,0xe5,0x7e,0x48,0x6f,0x34,0x6d,0x00,0xf8,0xff,0xff]
          vmovrsd  -2048(,%rbp,2), %zmm22

// CHECK: vmovrsd  8128(%rcx), %zmm22 {%k7} {z}
// CHECK: encoding: [0x62,0xe5,0x7e,0xcf,0x6f,0x71,0x7f]
          vmovrsd  8128(%rcx), %zmm22 {%k7} {z}

// CHECK: vmovrsd  -8192(%rdx), %zmm22 {%k7} {z}
// CHECK: encoding: [0x62,0xe5,0x7e,0xcf,0x6f,0x72,0x80]
          vmovrsd  -8192(%rdx), %zmm22 {%k7} {z}

// CHECK: vmovrsq  268435456(%rbp,%r14,8), %zmm22
// CHECK: encoding: [0x62,0xa5,0xfe,0x48,0x6f,0xb4,0xf5,0x00,0x00,0x00,0x10]
          vmovrsq  268435456(%rbp,%r14,8), %zmm22

// CHECK: vmovrsq  291(%r8,%rax,4), %zmm22 {%k7}
// CHECK: encoding: [0x62,0xc5,0xfe,0x4f,0x6f,0xb4,0x80,0x23,0x01,0x00,0x00]
          vmovrsq  291(%r8,%rax,4), %zmm22 {%k7}

// CHECK: vmovrsq  (%rip), %zmm22
// CHECK: encoding: [0x62,0xe5,0xfe,0x48,0x6f,0x35,0x00,0x00,0x00,0x00]
          vmovrsq  (%rip), %zmm22

// CHECK: vmovrsq  -2048(,%rbp,2), %zmm22
// CHECK: encoding: [0x62,0xe5,0xfe,0x48,0x6f,0x34,0x6d,0x00,0xf8,0xff,0xff]
          vmovrsq  -2048(,%rbp,2), %zmm22

// CHECK: vmovrsq  8128(%rcx), %zmm22 {%k7} {z}
// CHECK: encoding: [0x62,0xe5,0xfe,0xcf,0x6f,0x71,0x7f]
          vmovrsq  8128(%rcx), %zmm22 {%k7} {z}

// CHECK: vmovrsq  -8192(%rdx), %zmm22 {%k7} {z}
// CHECK: encoding: [0x62,0xe5,0xfe,0xcf,0x6f,0x72,0x80]
          vmovrsq  -8192(%rdx), %zmm22 {%k7} {z}

// CHECK: vmovrsw  268435456(%rbp,%r14,8), %zmm22
// CHECK: encoding: [0x62,0xa5,0xff,0x48,0x6f,0xb4,0xf5,0x00,0x00,0x00,0x10]
          vmovrsw  268435456(%rbp,%r14,8), %zmm22

// CHECK: vmovrsw  291(%r8,%rax,4), %zmm22 {%k7}
// CHECK: encoding: [0x62,0xc5,0xff,0x4f,0x6f,0xb4,0x80,0x23,0x01,0x00,0x00]
          vmovrsw  291(%r8,%rax,4), %zmm22 {%k7}

// CHECK: vmovrsw  (%rip), %zmm22
// CHECK: encoding: [0x62,0xe5,0xff,0x48,0x6f,0x35,0x00,0x00,0x00,0x00]
          vmovrsw  (%rip), %zmm22

// CHECK: vmovrsw  -2048(,%rbp,2), %zmm22
// CHECK: encoding: [0x62,0xe5,0xff,0x48,0x6f,0x34,0x6d,0x00,0xf8,0xff,0xff]
          vmovrsw  -2048(,%rbp,2), %zmm22

// CHECK: vmovrsw  8128(%rcx), %zmm22 {%k7} {z}
// CHECK: encoding: [0x62,0xe5,0xff,0xcf,0x6f,0x71,0x7f]
          vmovrsw  8128(%rcx), %zmm22 {%k7} {z}

// CHECK: vmovrsw  -8192(%rdx), %zmm22 {%k7} {z}
// CHECK: encoding: [0x62,0xe5,0xff,0xcf,0x6f,0x72,0x80]
          vmovrsw  -8192(%rdx), %zmm22 {%k7} {z}

